import csv
import sys

def main(filename):
    min_start = None
    max_finish = None

    with open(filename, newline='') as csvfile:
        reader = csv.reader(csvfile)
        header = next(reader)  # Skip header

        for row in reader:
            if len(row) < 3:
                continue  # Skip malformed rows
            start = int(row[1].strip())
            finish = int(row[2].strip())

            if min_start is None or start < min_start:
                min_start = start
            if max_finish is None or finish > max_finish:
                max_finish = finish

    print(f"Min start time: {min_start}")
    print(f"Max finish time: {max_finish}")

if __name__ == "__main__":
    if len(sys.argv) != 2:
        print("Usage: python getResults.py <csv_file>")
    else:
        main(sys.argv[1])